-- ToolStar Function Script
--
-- author: Bluebaby210		www.mod-portal.com
-- version: v1.0
--
-- combined to one script by [FSM]Chefkoch
--

toolStar = {};

function toolStar.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cylindered, specializations);
end;

function toolStar:load(xmlFile)
	self.setSelectedAttacherLight = SpecializationUtil.callSpecializationsFunction("setSelectedAttacherLight");

	self.attacherLightsIndex = {};
	local i = 0;
	while true do
		local baseName = string.format("vehicle.attacherJointLights.light(%d)", i); 
		local index =  Utils.indexToObject(self.components, getXMLString(xmlFile, baseName.. "#index")); 
		if index == nil then 
			break; 
		end; 
		table.insert(self.attacherLightsIndex, index)
		setVisibility(index, false)
		i = i+1
	end;
end;

function toolStar:delete()
end;

function toolStar:mouseEvent(posX, posY, isDown, isUp, button)
end;

function toolStar:keyEvent(unicode, sym, modifier, isDown)
end;

function toolStar:readStream(streamId, connection)
end;

function toolStar:writeStream(streamId, connection)
end;

function toolStar:readStreamUpdate(streamId, connection)
end;

function toolStar:writeStreamUpdate(streamId, connection)
end;

function toolStar:updateTick(dt)
	if self.isActive then
		if #self.attachedImplements > 0 then
			local select = false;
			for k,v in pairs(self.attachedImplements) do
				if v.object ~= nil then
					if v.object.isSelected then
						select = v.object.isSelected;
						local jointDescIndex = v.jointDescIndex
						self:setSelectedAttacherLight(jointDescIndex);
					end;
				end;
				if not select then
					self:setSelectedAttacherLight(0);
				end;
			end;
		end;
	end;
end;

function toolStar:update(dt)
	if self.isActive then
		for k,v in pairs(self.animations) do
			if self:getIsAnimationPlaying(k) then
				for _, tool in pairs(self.movingTools) do
					if self.isServer then
						Cylindered.setDirty(self, tool);
						self:raiseDirtyFlags(self.cylinderedDirtyFlag);
					end;
				end;
			end;
		end;
	end;
end;

function toolStar:draw()
end;

function toolStar:setSelectedAttacherLight(index)
	for i=1, #self.attacherLightsIndex do
		setVisibility(self.attacherLightsIndex[i], i==index)
	end;
end;

function toolStar:attachImplement(implement)
	self:setSelectedAttacherLight(0);
	if implement ~= nil then
		setMass(implement.object.rootNode, getMass(implement.object.rootNode)*0.1);
	end;
end;

function toolStar:detachImplement(implementIndex)
	self:setSelectedAttacherLight(0);
	local implement = self.attachedImplements[implementIndex];
	if implement ~= nil then
		setMass(implement.object.rootNode, getMass(implement.object.rootNode)/0.1)
	end;
end;

function toolStar:onAttach()
	self:setSelectedAttacherLight(0);
end;

function toolStar:onDetach()
	self:setSelectedAttacherLight(0);
end;

function toolStar:onDeactivate()
	self:setSelectedAttacherLight(0);
end;
